#pragma once

#include <cstdlib>
#include <vector>
#include <unordered_map>
#include <string>
#include "base.h"

using namespace std;

class fractal_testcase_adversary : public testcase_adversary {
  typedef __int128_t bigint;

  public:
    fractal_testcase_adversary(int max_pattern_size, string &curr, unordered_map<string, bigint> &stat) :
      max_pattern_size(max_pattern_size), flipped(false), curr(curr), pattern_stat(stat) {}

    int write(int B) {
      if(flipped) {
        flipped = false;
        update(B);
        return B;
      }

      else {
        int R = rand() % 2;
        if(val(R) < val(1 - R)) R = 1 - R;
        //fprintf(stderr, "<%lld|%lld>", (long long) val(R), (long long) val(1 - R));

        flipped = (R != B);
        update(R);
        return R;
      }
    }

  private:
    bigint val(int bit) {
      bigint r = 0;

      for(int i = 2; i <= min((int) curr.size(), max_pattern_size - 1); ++i)
        r += pattern_stat[curr.substr(curr.size() - i) + (char)(bit + '0')] * i * i;
      return r;
    }

    void update(int bit) {
      curr.push_back('0' + bit);
    }

    int max_pattern_size;
    bool flipped;
    string &curr;
    unordered_map<string, bigint> &pattern_stat;
};

class fractal_adversary : public adversary {
  typedef __int128_t bigint;

  public:
    fractal_adversary(int max_pattern_size) : max_pattern_size(max_pattern_size) {}

    pair<int, int> testcase(int T, int t, int MAX_N) {
      update_stats();

      testcaseAdversary = new fractal_testcase_adversary(max_pattern_size, s, pattern_stat);
      return {MAX_N, rand() % MAX_N + 1};
    }

  protected:
    int max_pattern_size;
    string s;
    unordered_map<string, bigint> pattern_stat;

    void update_stats() {
      for(int i = 0; i < s.size(); ++i)
        for(int l = 1; i + l < s.size(); ++l)
          pattern_stat[s.substr(i, l)] = pattern_stat[s.substr(i, l)] + s.size() * (bigint) s.size();
      s = "";
    }
};