#include <cstdio>
#include <cstdlib>
#include <cassert>
#include "communication.h"

using namespace std;

//#define DEBUG

template<typename... Ts> void _write_helper(int line, Ts... params) {
  printf(params...);
  fflush(stdout);

    #ifdef DEBUG
      fprintf(stderr, "[line %d] ", line);
      fprintf(stderr, params...);
    #endif
}

#define _write(...) _write_helper(__LINE__, __VA_ARGS__)

namespace {
  constexpr int TESTCASE = 510370837,
                   WRITE = 849256539,
                    READ = 410973902,
                  ANSWER = 167086295,
                    QUIT = 347829392,
                 GOODBYE =  42424242;
}

int read_int_or_exit_base(int line) {
  int r, scanf_return = scanf("%d", &r);
  if(scanf_return == EOF or r == -1) exit(0);
  return r;
}

#define read_int_or_exit() read_int_or_exit_base(__LINE__)

int send(int B) {
  _write("%d %d\n", WRITE, B);
  return read_int_or_exit();
}

int receive() {
  _write("%d\n", READ);
  return read_int_or_exit();
}

void _answer(pair<int, int> ans) {
  _write("%d %d %d\n", ANSWER, ans.first, ans.second);
}

void _do_encode(int N, int X) {
  encode(N, X);
  _write("%d\n", QUIT);
}

void _do_decode(int N) {
  auto r = decode(N);
  _answer(r);
}

int main() {
  for(int i = 0; ; ++i) {
    int C = read_int_or_exit();
    _write("%d\n", TESTCASE);
    int N = read_int_or_exit();

    if (C == 1) {
      int X = read_int_or_exit();
      _do_encode(N, X);
      assert(read_int_or_exit() == GOODBYE);
    }

    else {
      _do_decode(N);
      assert(read_int_or_exit() == GOODBYE);
    }
  }
}